import _pyhl
from Numeric import *

def createDataset():
    a=zeros((256,3),'b')
    for i in range(0,256):
	a[i][0]=i
    return a

def create_file():
    a=_pyhl.nodelist()

    # First create the dataset
    b=_pyhl.node(_pyhl.DATASET_ID,"/DATASET")
    c=createDataset()
    b.setArrayValue(1,[256,3],c,"uchar",-1)
    a.addNode(b)

    # Create an attribute in dataset
    b=_pyhl.node(_pyhl.ATTRIBUTE_ID,"/DATASET/ATTRIBUTE")
    b.setScalarValue(-1,"STRING ATTRIBUTE IN DATASET","string",-1)
    a.addNode(b)
    
    # Create an attribute
    b=_pyhl.node(_pyhl.ATTRIBUTE_ID,"/ATTRIBUTE")
    b.setScalarValue(-1,"STRING ATTRIBUTE","string",-1)
    a.addNode(b)

    # Create a group, that can contain a dataset
    b=_pyhl.node(_pyhl.GROUP_ID,"/GROUP")
    a.addNode(b)
    
    # Add dataset to this group
    b=_pyhl.node(_pyhl.DATASET_ID,"/GROUP/DATASET")
    b.setArrayValue(1,[256,3],c,"uchar",-1)
    a.addNode(b)

    # Add attribute to this group
    b=_pyhl.node(_pyhl.ATTRIBUTE_ID,"/GROUP/ATTRIBUTE")
    b.setScalarValue(-1,"STRING ATTRIBUTE IN GROUP","string",-1)
    a.addNode(b)
    

    # Now create references a little everywhere
    # First insert reference in dataset to point at dataset
    b=_pyhl.node(_pyhl.REFERENCE_ID,"/DATASET/DSET_REFERENCE")
    b.setScalarValue(-1,"/DATASET","string",-1)
    a.addNode(b)

    # Create reference in dataset to point at dataset in group
    b=_pyhl.node(_pyhl.REFERENCE_ID,"/DATASET/GROUPDSET_REFERENCE")
    b.setScalarValue(-1,"/GROUP/DATASET","string",-1)
    a.addNode(b)

    # Create reference in dataset to point at group
    b=_pyhl.node(_pyhl.REFERENCE_ID,"/DATASET/GROUP_REFERENCE")
    b.setScalarValue(-1,"/GROUP","string",-1)
    a.addNode(b)

    # Insert reference in dataset to point at attribute in dataset
    b=_pyhl.node(_pyhl.REFERENCE_ID,"/DATASET/ATTR_REFERENCE")
    b.setScalarValue(-1,"/DATASET/ATTRIBUTE","string",-1)
    a.addNode(b)

    # Insert reference in root to point at dataset
    b=_pyhl.node(_pyhl.REFERENCE_ID,"/DSET_REFERENCE")
    b.setScalarValue(-1,"/DATASET","string",-1)
    a.addNode(b)

    # Insert reference in root to point at attribute in dataset
    b=_pyhl.node(_pyhl.REFERENCE_ID,"/ATTR_REFERENCE")
    b.setScalarValue(-1,"/DATASET/ATTRIBUTE","string",-1)
    a.addNode(b)

    # Insert reference in root to point at attribute in root
    b=_pyhl.node(_pyhl.REFERENCE_ID,"/ROOT_ATTR_REFERENCE")
    b.setScalarValue(-1,"/ATTRIBUTE","string",-1)
    a.addNode(b)

    # Insert reference in root to point at attribute in dataset
    b=_pyhl.node(_pyhl.REFERENCE_ID,"/ROOT_DSET_REFERENCE")
    b.setScalarValue(-1,"/DATASET/ATTRIBUTE","string",-1)
    a.addNode(b)

    a.write("ahewrittenrefs.hdf")

if __name__=="__main__":
    create_file()
